<template>
  <div>
    <HeaderPayment :payments="payments"/>
    <ObTable
        :items="payments"
        :columns="columns"
        :page-limit="15"
        :footerDisabled="isFooterDisabled"
        data-qa="payment-order"
    >
      <div slot="ButtonDetails" slot-scope="{ data }">
        <ButtonDetails :item="data.item"/>
      </div>
      <div slot="NumberAccrual" slot-scope="{ data }">
        <NumberAccrual :item="data.item"/>
      </div>
      <div slot="PaymentAndDate" slot-scope="{ data }">
        <PaymentAndDate :item="data.item"/>
      </div>
      <div slot="BlockStatus" slot-scope="{ data }">
        <BlockStatus :item="data.item"/>
      </div>
    </ObTable>
  </div>
</template>

<script>
  import HeaderPayment from './headerPayment'
  import ObTable from 'common-components/src/obComponents/obTable';
  import ButtonDetails from '../slots/buttonDetails';
  import NumberAccrual from '../slots/numberAccrual';
  import PaymentAndDate from '../slots/paymentAndDate';
  import BlockStatus from '../slots/blockStatus';
  import moment from 'moment'

  export default {
    name: "tablePayment",
    components: {
      HeaderPayment,
      ObTable,
      ButtonDetails,
      NumberAccrual,
      PaymentAndDate,
      BlockStatus
    },
    props: {
      order: {
        type:  Object,
        default: () => {}
      },
      payments: {
        type: Array,
        default: () => []
      },
      isFooterDisabled: {
        type: Boolean,
        default: false
      }
    },
    computed: {
      columns () {
        const isSuborder = this.order.isSuborder
        return [
          {
            title: '',
            key: 'ButtonDetails',
            slotName: 'ButtonDetails',
            width: 20
          },
          {
            title: 'Номер начисления',
            key: 'NumberAccrual',
            slotName: 'NumberAccrual'
          },
          {
            title: 'Начислено',
            key: 'accruedAt',
            html: ({ accruedAt }) => accruedAt ? moment(accruedAt).format('DD.MM.YYYY') : '-'
          },
          {
            title: 'Передано в 1C',
            key: 'exposedAtIn1C',
            html: ({ exposedAtIn1C }) => exposedAtIn1C ? moment(exposedAtIn1C).format('DD.MM.YYYY') : '-'
          },
          {
            title: isSuborder ? 'Номер приходной накладной в 1С' : 'Номер счета в 1С',
            key: 'docNumber',
            html: ({ docNumber }) => docNumber || '-'
          },
          {
            title: 'Оплата и срок',
            key: 'PaymentAndDate',
            slotName: 'PaymentAndDate'
          },
          {
            title: 'Статус',
            key: 'BlockStatus',
            slotName: 'BlockStatus',
            exactWidth: '200px'
          }
        ]
      }
    }
  }
</script>
